summaryrefslogtreecommitdiff
path: root/tests/misc/truncate-overflow.sh
diff options
context:
space:
mode:
Diffstat (limited to 'tests/misc/truncate-overflow.sh')
-rwxr-xr-xtests/misc/truncate-overflow.sh39
1 files changed, 39 insertions, 0 deletions
diff --git a/tests/misc/truncate-overflow.sh b/tests/misc/truncate-overflow.sh
new file mode 100755
index 0000000..476bf49
--- /dev/null
+++ b/tests/misc/truncate-overflow.sh
@@ -0,0 +1,39 @@
+#!/bin/sh
+# Validate truncate integer overflow
+
+# Copyright (C) 2008-2016 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ truncate
+getlimits_
+
+
+# -= overflow
+truncate -s-1 create-zero-len-file || fail=1
+
+echo > non-empty-file
+
+# signed overflow
+returns_ 1 truncate -s$OFF_T_OFLOW file || fail=1
+
+# += signed overflow
+returns_ 1 truncate -s+$OFF_T_MAX non-empty-file || fail=1
+
+# *= signed overflow
+IO_BLOCK_OFLOW=$(expr $OFF_T_MAX / $(stat -f -c%s .) + 1)
+returns_ 1 truncate --io-blocks --size=$IO_BLOCK_OFLOW file || fail=1
+
+Exit $fail